%include "init.inc"

[org 0]
    jmp 07C0h:start

start:
    mov ax, cs
    mov ds, ax
    mov es, ax

    mov ax, 0xB800
    mov es, ax
    mov di, 0
    mov ax, word[msgBack]
    mov cx, 0x7FF

paint:
    mov word[es:di], ax
    add di, 2
    dec cx
    jnz paint

read:
    mov ax, 0x1000      ;ES:BX = 1000:0000
    mov es, ax
    xor bx, bx

    mov ah, 2           ; ũ ִ ͸ es:bx ּҷ
    mov al, 1           ; 1͸ ̴.
    mov ch, 0           ; 0° cylinder
    mov cl, 2           ; 2° ͺ б Ѵ.
    mov dh, 0           ; head = 0
    mov dl, 0           ; drive= 0, A: ̺
    int 0x13            ; read

    jc read             ;   ٽ

    cli

    lgdt[gdtr]

    mov eax, cr0
    or  eax, 0x00000001
    mov cr0, eax

    jmp $+2
    nop
    nop

    mov bx, SysDataSelector
    mov ds, bx
    mov es, bx
    mov fs, bx
    mov gs, bx
    mov ss, bx

;    db  0x66
;    db  0x67
;    db  0xEA
;    dd  PM_Start
;    dw  SysCodeSelector
    jmp dword SysCodeSelector:0x10000

msgBack db  '.', 0x67


;-------------------------------------------------------------------------
;           GDT(Global Descriptor Table)
;               BaseAddress, Descriptor size, Atribute
;-------------------------------------------------------------------------
gdtr:
    dw  gdt_end - gdt -1    ; Limit of GDT  == sizeof(gdtr)
    dd  gdt + 0x7C00        ; base address of GDT

;-------------------------------------------------------------------------
;              Descriptor
;   +---------------+---------------+
;   |   Limit(15 ~ 0 bit)           |
;   +---------------+---------------+
;   |   Base Address(15 ~ 0 bit)    |
;   +---------------+---------------+
;   |P |DPL |S|Type | Base 23 ~ 16  |
;   +---------------+---------------+
;   |Base 31 ~24    |G|D|0|A|limit  |
;   +---------------+---------------+
;-------------------------------------------------------------------------
gdt:
    dd  0,  0
    dd  0x0000FFFF, 0x00CF9A00
    dd  0x0000FFFF, 0x00CF9200
    dd  0x8000FFFF, 0x0040920B
; NULL Descriptor
;    dw  0                   ; limit 0 ~ 15 bit
;    dw  0                   ; base address   byte
;    db  0                   ; base address 16 ~ 32
;    db  0                   ; type
;    db  0                   ; limit 15 ~ 19 bit, Flag
;    db  0                   ; base address 24 ~ 31 bit
;
;; Code segment Descriptor
;    dw  0xFFFF              ; limit 0 ~ 15bit
;    dw  0x0000              ; base address   byte
;    db  0x01                ; base address 16 ~ 32
;    db  0x9A                ; type(P:1, DPL:0, Code, non-conforming, readable
;    db  0xCF                ; limit 15 ~ 19 bit, Flag(G:0, D:1, limit 0xF)
;    db  0x00                ; base address 24 ~ 31 bit
;
;; Data segment Descriptor
;    dw  0xFFFF              ; limit 0 ~ 15bit
;    dw  0x0000              ; base address   byte
;    db  0x01                ; base address 16 ~ 32
;    db  0x92                ; type(P:1, DPL:0, Data, expand-up, writable
;    db  0xCF                ; limit 15 ~ 19 bit, Flag(G:0, D:1, limit 0xF)
;    db  0x00                ; base address 24 ~ 31 bit
;
;; Video segment Descriptor
;    dw  0xFFFF              ; limit 0 ~ 15bit
;    dw  0x8000              ; base address   byte
;    db  0x0B                ; base address 16 ~ 32
;    db  0x92                ; type(P:1, DPL:0, Data, expand-up, writable
;    db  0x40                ; limit 15 ~ 19 bit, Flag(G:0, D:1, limit 0x0)
;    db  0x00                ; base address 24 ~ 31 bit
;
gdt_end:


times   510-($-$$)  db  0
dw  0AA55h
